#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <glib-2.0/glib.h>

int main (int argc, char *argv[])
{
    gchar *log_domain = NULL;
    int log_level = G_LOG_LEVEL_WARNING;
//    FILE *fp;
//    if ((fp = fopen("/tmp/fatal_args", "a")) == NULL)
//    {
//        return -1;
//
//    }
//    fprintf(fp,  "===========================\n");
//    fprintf(fp,  "Start spawning process.\n");

    log_level = atoi(argv[2]);
    log_domain = (strcmp("TRUE", argv[1]) == 0)? NULL : argv[3];

    if(strcmp("TRUE", argv[1]) == 0)
    {
//        fprintf(fp,  ">>>g_log_set_always_fatal(%d).\n", log_level);
        g_log_set_always_fatal(log_level);
    }
    else if(strcmp("ERROR", argv[1]) == 0)
    {
         log_level = G_LOG_LEVEL_ERROR;
//         fprintf(fp,  ">>>G_LOG_LEVEL_ERROR.\n");
    }
    else
    {
        g_log_set_fatal_mask(log_domain, log_level);
//        fprintf(fp,  ">>>g_log_set_fatal_mask(%s, %d).\n", log_domain, log_level);
    }


//      fprintf(fp,  "Arguments: \n");
//      fprintf(fp, " 0 argument %s\n", argv[0]);
//      fprintf(fp, " is Always %s\n", argv[1]);
//      fprintf(fp, " log_domain %s\n", argv[3]);
//      fprintf(fp, " log level %s\n", argv[2]);
//      fclose(fp);
      g_log (log_domain, log_level, "This message must terminate the program.");
    return 0;
}
