
#include <string.h> /* memset() */

#include "gt-common.h"
#include "gt-prichild.h"


/* here are local prototypes */
static void gt_prichild_iface_init (GTPRIChildIface * class);


GType
gt_prichild_get_type (void)
{
	static GType type = 0;
	if(type == 0) {
		static const GTypeInfo info = {
			sizeof (GTPRIChildIface),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) gt_prichild_iface_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			0,
			0 /* n_preallocs */,
			(GInstanceInitFunc) NULL,
			NULL
		};

		type = g_type_register_static (G_TYPE_INTERFACE, "GTPRIChild", &info, (GTypeFlags)0);
	}
	return type;
}



static void
gt_prichild_iface_init (GTPRIChildIface * iface)
{

	GParamSpec *param_spec_intIfaceProperty = g_param_spec_int
		("intIfaceProperty" /* name */,
		 "int Property" /* nick */,
		 "" /* blurb */,
		 -142 /* minimum */,
		 156 /* maximum */,
		 16 /* default_value */,
		 (GParamFlags)(G_PARAM_READABLE | G_PARAM_WRITABLE));

	g_object_interface_install_property (iface,
		param_spec_intIfaceProperty);

	GParamSpec *param_spec_stringIfaceProperty = g_param_spec_string
		("stringIfaceProperty" /* name */,
		 "string iface property" /* nick */,
		 "" /* blurb */,
		 "def_Value" /* default_value */,
		 (GParamFlags)(G_PARAM_READABLE | G_PARAM_WRITABLE));

	g_object_interface_install_property (iface,
		param_spec_stringIfaceProperty);

 {

	probjects_ct.properties_installed = TRUE;
	g_hash_table_insert(probjects_ct.propspec_map, "i_intIfaceProperty", param_spec_intIfaceProperty);
	g_hash_table_insert(probjects_ct.propspec_map, "i_stringIfaceProperty", param_spec_stringIfaceProperty);

 }
}




