#ifndef GTTPIDYNLIST_H_
#define GTTPIDYNLIST_H_

#include <glib.h>
#include <glib-object.h>



#define GTTP_TYPE_IDYNLIST           (gttp_type_idynlist_t)

#define GTTP_IDYNLIST(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_IDYNLIST,  GTTPIDynList))
#define GTTP_IS_IDYNLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_IDYNLIST))
#define GTTP_IDYNLIST_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GTTP_TYPE_IDYNLIST, GTTPIDynListIface))


#define GTTP_TYPE_IDYNLIST_NAME       "GTTPIDynList"
#define GTTP_TYPE_IDYNLIST_CLASS_INFO    idynlist_type_info

typedef struct _GTTPIDynList GTTPIDynList;
typedef struct _GTTPIDynListIface GTTPIDynListIface;


struct _GTTPIDynListIface
{
  GTypeInterface base_iface;

};



GType test_register_gttp_type_idynlist(const gchar* type_name,
                                        GTypePlugin* plugin,
                                        GTypeFlags type_flags,
                                        const gpointer class_data);

extern GTypeInfo idynlist_type_info;
extern GType gttp_type_idynlist_t;

#endif /*GTTPIDYNLIST_H_*/
