#ifndef GTTPTREEMAP_H_
#define GTTPTREEMAP_H_


#include "gttp-fmap.h"



#define GTTP_TYPE_TREEMAP       (register_gttp_treemap_type())

#define GTTP_TREEMAP_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_TREEMAP, GTTPTreeMapClass))
#define GTTP_IS_TREEMAP_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_TREEMAP))

#define GTTP_TREEMAP(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_TREEMAP,  GTTPTreeMap))
#define GTTP_IS_TREEMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_TREEMAP))
#define GTTP_TREEMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_TREEMAP, GTTPTreeMapClass))


typedef struct _GTTPTreeMap GTTPTreeMap;
typedef struct _GTTPTreeMapClass GTTPTreeMapClass;

struct _GTTPTreeMap{
    GTTPFMap parent_object;

};

struct _GTTPTreeMapClass{
    GTTPFMapClass parent_class;

    gchar field_char;
    glong field_long;
    gint field_int;

};

//Type registration
GType register_gttp_treemap_type();
GType test_register_gttp_treemap_type(const gchar* type_name,
                                    GType parent_type,
                                    GType imap_iface_type,
                                    GTypeFlags type_flags,
                                    const gpointer class_data, const gpointer imap_iface_data);


#endif /*GTTPTREEMAP_H_*/
