
#include "gttp-actionset.h"

static void gttp_actionset_base_init(gpointer g_class);
static void gttp_actionset_base_finalize(gpointer g_class);
static void gttp_actionset_class_init(gpointer g_class, gpointer class_data);
//void gttp_actionset_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_actionset_instance_init(GTypeInstance *instance, gpointer g_class);


static void gttp_actionset_interface_init (gpointer g_iface, gpointer iface_data);
static void gttp_actionset_interface_finalize (gpointer g_iface, gpointer iface_data);
//static gdouble __gttp_actionset_distance(GTTPActionSet* self, GTTPActionSet* other_actionset);
//static void __gttp_actionset_translate(GTTPActionSet* self, int x, int y);


GType gttp_type_actionset = 0;

GType register_gttp_actionset_type(const gchar* type_name, GTypeFlags type_flags, const gpointer class_data)
{

    if(gttp_type_actionset == 0)
    {
        gttp_type_actionset = test_register_gttp_actionset_type(GTTP_TYPE_FSET, GTTP_TYPE_IREQACTION, GTTP_TYPE_IACTION, NULL, type_flags, class_data, NULL);
    }

    return gttp_type_actionset;
}

GType test_register_gttp_actionset_type(GType parent_type, GType iface1_type, GType iface2_type, const gchar* type_name, GTypeFlags type_flags, const gpointer class_data, const gpointer interface_data)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);

    guint16 class_size = is_classed ? sizeof(GTTPActionSetClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_actionset_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_actionset_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_actionset_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = is_instantiable ? gttp_actionset_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPActionSet) : 0;

    GTypeInfo actionset_type_info = {
        class_size,  /* class_size */
        base_init_func,              /* base_init */
        base_finalize_func,          /* base_destroy */
        class_init_func,             /* class_init */
        class_finalize_func,         /* class_destroy */
        fclass_data,                  /* class_data */
        instance_size,       /* instance_size */
        0,                           /* n_preallocs */
        instance_init_func,          /* instance_init */
        NULL,                        /* value_table */
    };


    GType t_gttp_type_actionset = g_type_register_static (parent_type,
                            type_name,
                            &actionset_type_info,
                            type_flags);


    GInterfaceInfo iface_info = {
      gttp_actionset_interface_init,        /* interface_init */
      gttp_actionset_interface_finalize,    /* interface_finalize */
      interface_data                        /* interface_data */
    };


    g_type_add_interface_static (t_gttp_type_actionset,
                                 iface1_type,
                                 &iface_info);

    g_type_add_interface_static (t_gttp_type_actionset,
                                 iface2_type,
                                 &iface_info);

    return t_gttp_type_actionset;
}

//GTypeInfo methods

static void gttp_actionset_base_init(gpointer g_class)
{

}

static void gttp_actionset_base_finalize(gpointer g_class)
{

}

static void gttp_actionset_class_init(gpointer g_class, gpointer class_data)
{
//    GTTP_POINTSET_CLASS(g_class)->distance = __gttp_actionset_distance;
//    GTTP_POINTSET_CLASS(g_class)->translate = __gttp_actionset_translate;
}


//void gttp_actionset_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}

static void gttp_actionset_instance_init(GTypeInstance *instance, gpointer g_class)
{

}

//GInterfaceInfo methods

static void gttp_actionset_interface_init (gpointer g_iface, gpointer iface_data)
{
}

static void gttp_actionset_interface_finalize (gpointer g_iface, gpointer iface_data)
{

}


//Class public method wrappers



//Class methods


