
#include "gttp-ilist.h"
#include "t2c.h"
extern int bVerbose;

static void gttp_ilist_base_init(gpointer g_class);
static void gttp_ilist_base_finalize(gpointer g_class);
static void gttp_ilist_class_init(gpointer g_class, gpointer class_data);


GType gttp_type_ilist = 0;

GType register_gttp_type_ilist()
{
    if(gttp_type_ilist == 0)
    {
        gttp_type_ilist = test_register_gttp_type_ilist("GTTPIList", 0, NULL);
    }
    return gttp_type_ilist;
}

GTypeInfo ilist_type_info;

GType test_register_gttp_type_ilist(const gchar* type_name, GTypeFlags type_flags, const gpointer class_data)
{

    GBaseInitFunc base_init_func =  gttp_ilist_base_init;
    GBaseFinalizeFunc base_finalize_func = gttp_ilist_base_finalize;
    GClassInitFunc class_init_func =  gttp_ilist_class_init;

    ilist_type_info.class_size = sizeof (GTTPIListIface);
    ilist_type_info.base_init = base_init_func;
    ilist_type_info.base_finalize = base_finalize_func;
    ilist_type_info.class_init = class_init_func;
    ilist_type_info.class_finalize = NULL;
    ilist_type_info.class_data = class_data;
    ilist_type_info.instance_size = 0;
    ilist_type_info.n_preallocs = 0;
    ilist_type_info.instance_init = NULL;
    ilist_type_info.value_table = NULL;


    const gchar* itype_name = type_name == NULL ? "GTTPIList" : type_name;

    GType gttp_type_ilist_t = g_type_register_static(G_TYPE_INTERFACE,
                                                     itype_name,
                                                     &ilist_type_info,
                                                     type_flags);


    return gttp_type_ilist_t;
}

static void gttp_ilist_base_init(gpointer g_class)
{
//        TRACE("%s; g_class=%p;type=%s", __func__, g_class, g_type_name(G_TYPE_FROM_CLASS(g_class)))
}

static void gttp_ilist_base_finalize(gpointer g_class)
{

}

static void gttp_ilist_class_init(gpointer g_class, gpointer class_data)
{

}

gpointer gttp_ilist_get(GTTPIList* self, gint index)
{
    return GTTP_ILIST_GET_IFACE (self)->get (self, index);
}
