
#include "gttp-ireqaction.h"


void gttp_ireqaction_base_init(gpointer g_class);
void gttp_ireqaction_base_finalize(gpointer g_class);
void gttp_ireqaction_class_init(gpointer g_class, gpointer class_data);


GType gttp_type_ireqaction = 0;

GType register_gttp_type_ireqaction()
{
    if(gttp_type_ireqaction == 0)
    {
        gttp_type_ireqaction = test_register_gttp_type_ireqaction(NULL, 0, NULL);
    }
    return gttp_type_ireqaction;
}


GType test_register_gttp_type_ireqaction(const gchar* type_name, GTypeFlags type_flags, const gpointer class_data)
{


    static GTypeInfo type_info = {
        sizeof (GTTPIReqActionIface),
        gttp_ireqaction_base_init,
        gttp_ireqaction_base_finalize,
        gttp_ireqaction_class_init,
        NULL,
        NULL,                 /* class_data */
        0,
        0,                          /* n_preallocs */
        NULL,
        NULL
    };
    type_info.class_data = class_data;

    const gchar* itype_name = type_name == NULL ? "IReqAction" : type_name;

    GType gttp_type_ireqaction_t = g_type_register_static(G_TYPE_INTERFACE,
                                                     itype_name,
                                                     &type_info,
                                                     type_flags);


    g_type_interface_add_prerequisite(gttp_type_ireqaction_t, GTTP_TYPE_IACTION);


    return gttp_type_ireqaction_t;
}

void gttp_ireqaction_base_init(gpointer g_class)
{

}

void gttp_ireqaction_base_finalize(gpointer g_class)
{

}

void gttp_ireqaction_class_init(gpointer g_class, gpointer class_data)
{

}


