
#include <t2c.h>
extern int bVerbose;

#include "gttp-pointlist.h"

static void gttp_pointlist_base_init(gpointer g_class);
static void gttp_pointlist_base_finalize(gpointer g_class);
static void gttp_pointlist_class_init(gpointer g_class, gpointer class_data);
//static void gttp_pointlist_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_pointlist_instance_init(GTypeInstance *instance, gpointer g_class);

static void gttp_pointlist_interface_init (gpointer g_iface, gpointer iface_data);
static void gttp_pointlist_interface_finalize (gpointer g_iface, gpointer iface_data);
static gpointer  __gttp_pointlist_get(GTTPPointList* ilist, gint index);
static int __get_instance_count();
static int __get_instance_id(GTTPPointList *self) ;
static int __get_init_order(GTTPPointList *self);
static GTTPPointListPrivate* __gttp_pointlist_get_priv_pointlist(GTTPPointList *self);
static GTTPPointListPrivate* __gttp_pointlist_get_priv_pointset(GTTPPointList *self);
static GTTPPointListPrivate* __gttp_pointlist_get_priv_fset(GTTPPointList *self);
static void __gttp_pointlist_set_priv_pointlist(GTTPPointList *self, GTTPPointListPrivate *value);
static void __gttp_pointlist_set_priv_pointset(GTTPPointList *self, GTTPPointListPrivate *value);
static void __gttp_pointlist_set_priv_fset(GTTPPointList *self, GTTPPointListPrivate *value);


GType gttp_type_pointlist = 0;

GType register_gttp_pointlist_type(gboolean has_init)
{

    if(gttp_type_pointlist == 0)
    {
        gttp_type_pointlist = test_register_gttp_pointlist_type(GTTP_TYPE_POINTSET,
        														GTTP_TYPE_ILIST,
        														GTTP_TYPE_POINTLIST_NAME,
        														0, NULL, NULL, has_init);
    }

    return gttp_type_pointlist;
}

GTypeInfo pointlist_type_info;
GInterfaceInfo pointlist_ilist_info;

GType test_register_gttp_pointlist_type(GType parent_type,
										GType interface_type,
										const gchar* type_name,
										GTypeFlags type_flags,
										const gpointer class_data,
										const gpointer interface_data,
										gboolean has_init)
{

    const gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    const gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);

    const guint16 class_size = is_classed ? sizeof(GTTPPointListClass) : 0;

    const GBaseInitFunc base_init_func = is_classed ? gttp_pointlist_base_init : NULL;
    const GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_pointlist_base_finalize : NULL;
    const GClassInitFunc class_init_func = is_classed ? gttp_pointlist_class_init : NULL;
    const GClassFinalizeFunc class_finalize_func = NULL;
    const GInstanceInitFunc instance_init_func = is_instantiable ? gttp_pointlist_instance_init : NULL;


    const gconstpointer fclass_data = is_classed ? class_data : 0;

    const guint16 instance_size = is_instantiable ? sizeof(GTTPPointList) : 0;

    pointlist_type_info.class_size = class_size;
    pointlist_type_info.base_init = base_init_func;
    pointlist_type_info.base_finalize = base_finalize_func;
    pointlist_type_info.class_init = class_init_func;
    pointlist_type_info.class_finalize = class_finalize_func;
    pointlist_type_info.class_data = fclass_data;
    pointlist_type_info.instance_size = instance_size;
    pointlist_type_info.n_preallocs = 0;
    pointlist_type_info.instance_init = instance_init_func;
    pointlist_type_info.value_table = NULL;


    pointlist_ilist_info.interface_init = gttp_pointlist_interface_init;
    pointlist_ilist_info.interface_finalize = gttp_pointlist_interface_finalize;
    pointlist_ilist_info.interface_data = interface_data;


    GType t_gttp_type_pointlist = g_type_register_static (parent_type,
                            type_name,
                            &pointlist_type_info,
                            type_flags);


    g_type_add_interface_static (t_gttp_type_pointlist,
                                 interface_type,
                                 &pointlist_ilist_info);




    return t_gttp_type_pointlist;
}

//GTypeInfo methods

static void gttp_pointlist_base_init(gpointer g_class)
{

}

static void gttp_pointlist_base_finalize(gpointer g_class)
{

}


static void gttp_pointlist_class_init(gpointer g_class, gpointer class_data)
{
	if(g_class == NULL)
	{
		gttppointlist01_ct.class_not_null = FALSE;
		return;
	}

	if(!GTTP_IS_POINTSET_CLASS(g_class))
	{
		gttppointlist01_ct.local_class_type_is_valid = FALSE;
		return;
	}

	/*if(!G_TYPE_CHECK_CLASS_TYPE(g_class, gttppointlist01_ct.expected_class_type))
	{
		gttppointlist01_ct.expected_class_type_is_valid = FALSE;
		return;
	}*/

	gttppointlist01_ct.class_not_null = TRUE;
	gttppointlist01_ct.local_class_type_is_valid = TRUE;
	gttppointlist01_ct.expected_class_type_is_valid = TRUE;


    GTTP_POINTLIST_CLASS(g_class)->get_instance_count = __get_instance_count;
    GTTP_POINTLIST_CLASS(g_class)->get_instance_id = __get_instance_id;
	GTTP_POINTLIST_CLASS(g_class)->get_init_order = __get_init_order;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_set_priv_pointlist = __gttp_pointlist_set_priv_pointlist;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_set_priv_pointset = __gttp_pointlist_set_priv_pointset;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_set_priv_fset = __gttp_pointlist_set_priv_fset;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_get_priv_pointlist = __gttp_pointlist_get_priv_pointlist;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_get_priv_pointset = __gttp_pointlist_get_priv_pointset;
	GTTP_POINTLIST_CLASS(g_class)->gttp_pointlist_get_priv_fset = __gttp_pointlist_get_priv_fset;

	GTTP_POINTLIST_CLASS(g_class)->instance_count = 0;
	g_type_class_add_private (g_class, sizeof (GTTPPointListPrivate));
}

//static void gttp_pointlist_class_finalize(gpointer g_class, gpointer class_data)
//{
//
//}

static void gttp_pointlist_instance_init(GTypeInstance *instance, gpointer g_class)
{
	GTTPPointList *self;
	int paernt_iid;
	++gttppointlist01_ct.instance_count;
	if(instance == NULL)
	{
		TRACE("%s instance is NULL", __func__);
		gttppointlist01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointlist01_ct.instance_not_null = TRUE;
	if(g_class == NULL)
	{
		TRACE("%s g_class is NULL", __func__);
		gttppointlist01_ct.class_not_null = FALSE;
		return;
	}
	gttppointlist01_ct.class_not_null = TRUE;
	if(!GTTP_IS_POINTSET_CLASS(g_class))
	{
		TRACE("%s is not derived from FSET", __func__);
		gttppointlist01_ct.local_class_type_is_valid = FALSE;
		return;
	}
	gttppointlist01_ct.local_class_type_is_valid = TRUE;
	if(!GTTP_IS_POINTSET(instance))
	{
		TRACE("%s is not FSET instance", __func__);
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	if(!G_TYPE_CHECK_CLASS_TYPE(g_class, gttppointlist01_ct.expected_class_type))
	{
		TRACE("%s is expected class type", __func__);
		gttppointlist01_ct.expected_class_type_is_valid = FALSE;
		return;
	}
	gttppointlist01_ct.expected_class_type_is_valid = TRUE;
	if(!G_TYPE_FROM_INSTANCE(instance) == gttppointlist01_ct.expected_class_type)
	{
		TRACE("%s is not valid expected instance", __func__);
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
	self = GTTP_POINTLIST(instance);
	if( self->instance_id != 0 ) {
		TRACE("%s The instance id is not 0", __func__);
		gttppointlist01_ct.class_struct_zero_filled = FALSE;
		return;

	}
	gttppointlist01_ct.class_struct_zero_filled = TRUE;

	paernt_iid = gttp_pointset_get_instance_id(GTTP_POINTSET(self));
	if(paernt_iid < 1) {
		gttppointlist01_ct.init_call_order_valid = FALSE;
	} else {
		gttppointlist01_ct.init_call_order_valid = TRUE;
	}

	if(GTTP_POINTLIST_GET_POINTLIST_PRIVATE(self) == NULL) {
		gttppointlist01_ct.private_init_is_done = FALSE;
		return;
	}
	gttppointlist01_ct.private_init_is_done = TRUE;

    self->instance_id = gttppointlist01_ct.instance_count;

}

//GInterfaceInfo methods

static void gttp_pointlist_interface_init (gpointer g_iface, gpointer iface_data)
{
    if(gttppointlist_ct.icheck_handler_1_call_count > 0 ||
        gttppointlist_ct.icheck_handler_2_call_count > 0)
    {
        TRACE0("g_type_add_interface_check: interface check callback was called before 'GInterfaceInfo.interface_init' callback.");
        gttppointlist_ct.icheck_call_order_valid = FALSE;
        return;
    }

    gttppointlist_ct.icheck_call_order_valid = TRUE;
    gttppointlist_ct.exp_g_iface = g_iface;


    ((GTTPIListIface*)g_iface)->get =(gpointer  (*) (GTTPIList* ilist, gint index)) __gttp_pointlist_get;
}

static void gttp_pointlist_interface_finalize (gpointer g_iface, gpointer iface_data)
{

}

int gttp_pointlist_get_instance_count() {
	int ic = 0;
	GTTPPointListClass *p = g_type_class_ref(GTTP_TYPE_POINTLIST);
	ic = p->get_instance_count();
	g_type_class_unref(p);
	return ic;
}

int gttp_pointlist_get_instance_id(GTTPPointList *self) {
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_POINTSET(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointlist01_ct.instance_not_null = TRUE;
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
	return GTTP_POINTLIST_GET_CLASS(self)->get_instance_id(self);
}

int gttp_pointlist_get_init_order(GTTPPointList *self) {
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_POINTSET(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointlist01_ct.instance_not_null = TRUE;
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
	return GTTP_POINTLIST_GET_CLASS(self)->get_init_order(self);
}

GTTPPointListPrivate * gttp_pointlist_get_priv_pointlist(GTTPPointList *self)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_get_priv_pointlist(self);
}

GTTPPointListPrivate * gttp_pointlist_get_priv_pointset(GTTPPointList *self)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_get_priv_pointset(self);
}

GTTPPointListPrivate * gttp_pointlist_get_priv_fset(GTTPPointList *self)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return NULL;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return NULL;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	return GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_get_priv_fset(self);
}

void gttp_pointlist_set_priv_pointlist(GTTPPointList *self, GTTPPointListPrivate *svalue)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_set_priv_pointlist(self, svalue);
}

void gttp_pointlist_set_priv_pointset(GTTPPointList *self, GTTPPointListPrivate *svalue)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_set_priv_pointset(self, svalue);
}

void gttp_pointlist_set_priv_fset(GTTPPointList *self, GTTPPointListPrivate *svalue)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return;
	}
	gttppointlist01_ct.instance_not_null = TRUE;

	if(!GTTP_IS_POINTLIST(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;

	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return ;
	}
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;

	GTTP_POINTLIST_GET_CLASS(self)->gttp_pointlist_set_priv_fset(self, svalue);
}


//Class public method wrappers

gpointer gttp_pointlist_get(GTTPPointList* self, gint index)
{
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_POINTSET(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointlist01_ct.instance_not_null = TRUE;
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
    return GTTP_ILIST_GET_IFACE(self)->get(GTTP_ILIST(self), index);
}



//Class methods
static int __get_instance_count() {
	return gttppointlist01_ct.instance_count;
}

static int __get_instance_id(GTTPPointList *self) {
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_POINTSET(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointlist01_ct.instance_not_null = TRUE;
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
	return self->instance_id;
}

static int __get_init_order(GTTPPointList *self) {
	if(self == NULL)
	{
		gttppointlist01_ct.instance_not_null = FALSE;
		return FALSE;
	}


	if(!GTTP_IS_POINTSET(self))
	{
		gttppointlist01_ct.local_instance_type_is_valid = FALSE;
		return FALSE;
	}


	if(G_TYPE_FROM_INSTANCE(self) != gttppointlist01_ct.expected_class_type)
	{
		gttppointlist01_ct.expected_instance_type_is_valid = FALSE;
		return FALSE;
	}

	gttppointlist01_ct.instance_not_null = TRUE;
	gttppointlist01_ct.local_instance_type_is_valid = TRUE;
	gttppointlist01_ct.expected_instance_type_is_valid = TRUE;
	return self->parnet_init_order;
}



//Interface method implementation
gpointer  __gttp_pointlist_get(GTTPPointList* ilist, gint index)
{
    return NULL;
}


static GTTPPointListPrivate * __gttp_pointlist_get_priv_pointlist (GTTPPointList *pset)
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_POINTLIST_PRIVATE (pset);
 	return priv;
}

static GTTPPointListPrivate * __gttp_pointlist_get_priv_pointset (GTTPPointList *pset)
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_POINTSET_PRIVATE (pset);
 	return priv;
}

static GTTPPointListPrivate * __gttp_pointlist_get_priv_fset (GTTPPointList *pset)
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_FSET_PRIVATE (pset);
 	return priv;
}

static void __gttp_pointlist_set_priv_pointlist (GTTPPointList *pset, GTTPPointListPrivate *svalue )
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_POINTLIST_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPPointListPrivate));
}

static void __gttp_pointlist_set_priv_pointset (GTTPPointList *pset, GTTPPointListPrivate *svalue )
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_POINTSET_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPPointListPrivate));
}

static void __gttp_pointlist_set_priv_fset (GTTPPointList *pset, GTTPPointListPrivate *svalue )
{
 	GTTPPointListPrivate *priv = GTTP_POINTLIST_GET_FSET_PRIVATE (pset);
 	memcpy(priv, svalue, sizeof(GTTPPointListPrivate));
}

//Debugging and verification functions
gpointer get_pointlist_ilist_info()
{
    return &pointlist_ilist_info;
}
