
#include <string.h> /* memset() */

#include "gttm-iaction.h"


/* here are local prototypes */
static void gttm_iaction_iface_init (GTTMIActionIface * class);

GType gttm_iaction_type = 0;



void
gttm_iaction_register_type (GTypeModule *type_module, GType* reg_type_id)
{
    static const GTypeInfo info = {
        sizeof (GTTMIActionIface),
        (GBaseInitFunc) NULL,
        (GBaseFinalizeFunc) NULL,
        (GClassInitFunc) gttm_iaction_iface_init,
        (GClassFinalizeFunc) NULL,
        NULL /* class_data */,
        0,
        0 /* n_preallocs */,
        (GInstanceInitFunc) NULL,
        NULL
    };

    gttm_iaction_type = g_type_module_register_type (type_module,
                                            G_TYPE_INTERFACE,
                                            "GTTMIAction",
                                            &info,
                                            (GTypeFlags)0);
    if(reg_type_id)
        *reg_type_id = gttm_iaction_type;
}



void gttm_module_reg_iaction_type (GTypeModule *module, GType* reg_type_id)
{
  if(module == NULL)
  {
    return;
  }
  gttm_iaction_register_type (module, reg_type_id);
}



static void
gttm_iaction_iface_init (GTTMIActionIface * iface)
{


}




