#ifndef MY_ATK_ACTION1_H
#define MY_ATK_ACTION1_H

/*
 * Object, which implement interface AtkAction(only needed function).
 * Such behaiviour was reached using inheritance of MyAtkAction 
 * and filling some functions in virtual table with NULLs.
 */
#include <AtkAction/MyAtkAction.h>

//declarations
#define MY_TYPE_ATK_ACTION1             (my_atk_action1_get_type ())
#define MY_ATK_ACTION1(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_ATK_ACTION1, MyAtkAction1))
#define MY_ATK_ACTION1_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), MY_TYPE_ATK_ACTION1, MyAtkAction1Class))
#define MY_IS_ATK_ACTION1(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_ATK_ACTION1))
#define MY_IS_ATK_ACTION1_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), MY_TYPE_ATK_ACTION1))
#define MY_ATK_ACTION1_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_CLASS ((inst), MY_TYPE_ATK_ACTION1, MyAtkAction1Class))

typedef struct _MyAtkAction1 MyAtkAction1;
typedef struct _MyAtkAction1Class MyAtkAction1Class;

struct _MyAtkAction1
{
    MyAtkAction parent;
};

struct _MyAtkAction1Class
{
    MyAtkActionClass parent;
};

GType my_atk_action1_get_type(void);

//implementaion of interface
static void
my_atk_action1_interface_init(gpointer g_iface, gpointer iface_data)
{
    AtkActionIface *klass = (AtkActionIface *)g_iface;
    //remove realization of some interfaces
    klass->get_n_actions = NULL;
    klass->get_description = NULL;
    klass->get_name = NULL;
    klass->get_localized_name = NULL;
}
GType my_atk_action1_get_type(void)
{
    static GType type = 0;
    if(type == 0)
    {
        static const GTypeInfo info =
        {
            sizeof (MyAtkAction1Class),
            NULL,   /* base_init */
            NULL,   /* base_finalize */
            NULL,   /* class_init */
            NULL,   /* class_finalize */
            NULL,   /* class_data */
            sizeof (MyAtkAction1),
            0,      /* n_preallocs */
            NULL    /* instance_init */
        };
        type = g_type_register_static (MY_TYPE_ATK_ACTION,
            "MyAtkAction1",
            &info, 0);
        static const GInterfaceInfo iface_info = 
        {
            (GInterfaceInitFunc) my_atk_action1_interface_init,    /* interface_init */
            NULL,                                       /* interface_finalize */
            NULL                                        /* interface_data */
        };
        g_type_add_interface_static (type,
            ATK_TYPE_ACTION,
            &iface_info);
    }
    return type;    
}
#endif 
