#ifndef T2C_CHILD_PROCS_H_

#define T2C_CHILD_PROCS_H_

#define EXITCODE_ONFAIL 255 //max 8 bits (see WEXITSTATUS)

#define CHEK_FAIL_IN_CHILDPROCESS(ret_code)\
        {\
            if(WEXITSTATUS(ret_code) == EXITCODE_ONFAIL)\
            {\
                tet_result(TET_FAIL);\
                test_passed_flag = FALSE;\
                goto purpose_finally_section_;\
            }\
        }

#define CHILDPROCESS_END()\
        {\
          goto purpose_finally_section_;\
        }

#define CHILDPROCESS_EXIT(proc_id)\
        {\
            if(proc_id == 0)\
            {\
                if(test_passed_flag)\
                {\
                    exit(0);\
                }\
                else\
                {\
                    exit(EXITCODE_ONFAIL);\
                }\
            }\
        }

#endif /*T2C_CHILD_PROCS_H_*/
