
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 #include <errno.h>
 
#include "spawn_test.h"


int main (int argc, char *argv[])
{    
    char *env = NULL;
    env = getenv("LSB_SPAWN_TEST");
    if(env != NULL)
    {
        printf( env);
        printf( "\n");         
    }
    // open file descriptor
    // testing G_SPAWN_LEAVE_DESCRIPTORS_OPEN flag
    if (strcmp (argv[0], "sync_test") == 0 && strcmp (argv[1], "1") != 0)
    {
        int fd = atoi (argv[1]);
        if (fd > 1)
        {
            int newfd = dup2 (fd, fd);
            printf ("%d", newfd);
        }
        printf ("\n");
        goto cleanup;
    }

    // G_SPAWN_CHILD_INHERITS_STDIN flag checking
    if (strcmp (argv[2], "stdin") == 0 )
    {
        char buffer[100];
        // read from stdin 
        scanf ("%s", buffer);
        // write it to args file
        printf (buffer);
        goto cleanup;
    }
    int stderrno = fileno(stderr);
    int isat = isatty(stderrno);
    int nerror = errno;
    if (strcmp (argv[2], "stderr") == 0 )
    {   
        if (isat == 0 || errno>0) 
        {
            printf("ok");
        }
        else
        {
            printf("no");
        }
        goto cleanup;
    }
    
    while (argc && *argv)
    {
        printf( *argv);

        argc--, argv++;     
    }
    printf( "\n");
    fprintf(stderr, STDERR_TEXT);
cleanup:    
    return 0;
}
