#ifndef GTTPACTIONSET_H_
#define GTTPACTIONSET_H_


#include "gttp-fset.h"
#include "gttp-ireqaction.h"

/*
 * Proposed as direct descendant of the set class.
 *
 * Implementor of the GTTPIReqAction interface, which has
 * an IAction interface as a prerequisite.
 *
 */

extern GType gttp_type_actionset;

#define GTTP_TYPE_ACTIONSET       (gttp_type_actionset)

#define GTTP_ACTIONSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_ACTIONSET, GTTPActionSetClass))
#define GTTP_IS_ACTIONSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_ACTIONSET))

#define GTTP_ACTIONSET(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_ACTIONSET,  GTTPActionSet))
#define GTTP_IS_ACTIONSET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_ACTIONSET))
#define GTTP_ACTIONSET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_ACTIONSET, GTTPActionSetClass))


typedef struct _GTTPActionSet GTTPActionSet;
typedef struct _GTTPActionSetClass GTTPActionSetClass;

struct _GTTPActionSet{
    GTTPFSet parent_object;

};

struct _GTTPActionSetClass{
    GTTPFSetClass parent_class;

};



GType register_gttp_actionset_type(const gchar* type_name, GTypeFlags type_flags, const gpointer class_data);
GType test_register_gttp_actionset_type(GType parent_type, GType iface1_type, GType iface2_type, const gchar* type_name, GTypeFlags type_flags, const gpointer class_data, const gpointer interface_data);





#endif /*GTTPACTIONSET_H_*/
