#include <glib.h>
#include <glib-object.h>

#ifndef GTTPILIST_H_
#define GTTPILIST_H_


#define GTTP_TYPE_ILIST           (register_gttp_type_ilist())

#define GTTP_ILIST(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_ILIST,  GTTPIList))
#define GTTP_IS_ILIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_ILIST))
#define GTTP_ILIST_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GTTP_TYPE_ILIST, GTTPIListIface))



typedef struct _GTTPIList GTTPIList;
typedef struct _GTTPIListIface GTTPIListIface;


struct _GTTPIListIface
{
  GTypeInterface base_iface;

  gpointer  (*get) (GTTPIList* ilist, gint index);
};



GType register_gttp_type_ilist();
GType test_register_gttp_type_ilist(const gchar* type_name, GTypeFlags type_flags, const gpointer class_data);

gpointer gttp_ilist_get(GTTPIList* ilist, gint index);


#endif /*GTTPILIST_H_*/
