
#include <glib.h>
#include <glib-object.h>

#include <t2c.h>
extern int bVerbose;

#ifndef GTTPIMAP_H_
#define GTTPIMAP_H_

#include "gttp-common.h"


#define GTTP_TYPE_IMAP           (register_gttp_type_imap())

#define GTTP_IMAP(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_IMAP,  GTTPIMap))
#define GTTP_IS_IMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_IMAP))
#define GTTP_IMAP_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GTTP_TYPE_IMAP, GTTPIMapIface))



typedef struct _GTTPIMap GTTPIMap;
typedef struct _GTTPIMapIface GTTPIMapIface;


struct _GTTPIMapIface
{
  GTypeInterface base_iface;

  gint field_int;
  gdouble field_double;

};


GType register_gttp_type_imap();
GType test_register_gttp_type_imap(const gchar* type_name, GTypeFlags type_flags, gboolean base_init_enabled, gboolean class_init_enabled, const gpointer class_data);

gpointer gttp_imap_get(GTTPIMap* imap, gint index);





#endif /*GTTPIMAP_H_*/
