
#include "gttp-dynlist.h"

#include <t2c.h>
extern int bVerbose;

static void gttp_dynlist_base_init(gpointer g_class);
static void gttp_dynlist_base_finalize(gpointer g_class);
static void gttp_dynlist_class_init(gpointer g_class, gpointer class_data);
static void gttp_dynlist_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_dynlist_instance_init(GTypeInstance *instance, gpointer g_class);
static void gttp_dynlist_interface_init (gpointer g_iface, gpointer iface_data);
static void gttp_dynlist_interface_finalize (gpointer g_iface, gpointer iface_data);


GType gttp_type_dynlist_t = 0;
GTypeInfo dynlist_type_info;
GInterfaceInfo dynlist_idynlist_iface_info;

GType test_register_gttp_dynlist_type(GType parent_type,
                                     GType interface_type,
                                     GTypePlugin* plugin,
                                     const gchar* type_name,
                                     GTypeFlags type_flags,
                                     const gpointer class_data,
                                     const gpointer iface_data)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);


    guint16 class_size = is_classed ? sizeof(GTTPDynListClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_dynlist_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_dynlist_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_dynlist_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = is_classed? gttp_dynlist_class_finalize: NULL;
    GInstanceInitFunc instance_init_func = (is_instantiable) ? gttp_dynlist_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPDynList) : 0;

    dynlist_type_info.class_size = class_size;
    dynlist_type_info.base_init = base_init_func;
    dynlist_type_info.base_finalize = base_finalize_func;
    dynlist_type_info.class_init = class_init_func;
    dynlist_type_info.class_finalize = class_finalize_func;
    dynlist_type_info.class_data = fclass_data;
    dynlist_type_info.instance_size = instance_size;
    dynlist_type_info.n_preallocs = 0;
    dynlist_type_info.instance_init = instance_init_func;
    dynlist_type_info.value_table = NULL;


    const gchar* ctype_name = type_name == NULL ? "GTTPDynList" : type_name;

    dynlist_idynlist_iface_info.interface_init = gttp_dynlist_interface_init;
    dynlist_idynlist_iface_info.interface_finalize = gttp_dynlist_interface_finalize;
    dynlist_idynlist_iface_info.interface_data = iface_data;



    gttp_type_dynlist_t = g_type_register_dynamic(parent_type,
                                                 ctype_name,
                                                 plugin,
                                                 type_flags);

    g_type_add_interface_dynamic(gttp_type_dynlist_t,
                                 interface_type,
                                 plugin);


    return gttp_type_dynlist_t;
}


// Class initialization methods

static void gttp_dynlist_base_init(gpointer g_class)
{
    //TRACE("%s called.", __func__)
}

static void gttp_dynlist_base_finalize(gpointer g_class)
{
    //TRACE("%s called.", __func__)
}


static void gttp_dynlist_class_init(gpointer g_class, gpointer class_data)
{
    //TRACE("%s called.", __func__)
}


static void gttp_dynlist_class_finalize(gpointer g_class, gpointer class_data)
{
    //TRACE("%s called.", __func__)

    if(IS_USED_CT(gttpdynlist_ct))
    {
        gttpdynlist_ct.class_finalize_call_count++;
    }
}


//Instance initialization method

static void gttp_dynlist_instance_init(GTypeInstance *instance, gpointer g_class)
{
    //TRACE("%s called.", __func__)
}


//Interface initialization methods

static void gttp_dynlist_interface_init (gpointer g_iface, gpointer iface_data)
{
    //TRACE("%s called.", __func__)
}

static void gttp_dynlist_interface_finalize (gpointer g_iface, gpointer iface_data)
{
    //TRACE("%s called.", __func__)
}


//Public wrappers of the class methods





//Implementation of class methods


