
#include "gttp-idynlist.h"
#include "t2c.h"
extern int bVerbose;

static void gttp_idynlist_base_init(gpointer g_class);
static void gttp_idynlist_base_finalize(gpointer g_class);
static void gttp_idynlist_class_init(gpointer g_class, gpointer class_data);
static void gttp_idynlist_class_finalize(gpointer g_class, gpointer class_data);


GTypeInfo idynlist_type_info;
GType gttp_type_idynlist_t;

GType test_register_gttp_type_idynlist(const gchar* type_name,
                                        GTypePlugin* plugin,
                                        GTypeFlags type_flags,
                                        const gpointer class_data)
{

    GBaseInitFunc base_init_func =  gttp_idynlist_base_init;
    GBaseFinalizeFunc base_finalize_func = gttp_idynlist_base_finalize;
    GClassInitFunc class_init_func =  gttp_idynlist_class_init;
    GClassFinalizeFunc class_finalize_func = gttp_idynlist_class_finalize;

    idynlist_type_info.class_size = sizeof (GTTPIDynListIface);
    idynlist_type_info.base_init = base_init_func;
    idynlist_type_info.base_finalize = base_finalize_func;
    idynlist_type_info.class_init = class_init_func;
    idynlist_type_info.class_finalize = class_finalize_func;
    idynlist_type_info.class_data = class_data;
    idynlist_type_info.instance_size = 0;
    idynlist_type_info.n_preallocs = 0;
    idynlist_type_info.instance_init = NULL;
    idynlist_type_info.value_table = NULL;


    const gchar* itype_name = type_name == NULL ? "GTTPIDynList" : type_name;

//    GType gttp_type_idynlist_t = g_type_register_static(G_TYPE_INTERFACE,
//                                                     itype_name,
//                                                     &idynlist_type_info,
//                                                     type_flags);

    gttp_type_idynlist_t = g_type_register_dynamic(G_TYPE_INTERFACE,
                                                 itype_name,
                                                 plugin,
                                                 type_flags);


    return gttp_type_idynlist_t;
}

static void gttp_idynlist_base_init(gpointer g_class)
{
    //TRACE("%s called.", __func__)
}

static void gttp_idynlist_base_finalize(gpointer g_class)
{
    //TRACE("%s called.", __func__)
}

static void gttp_idynlist_class_init(gpointer g_class, gpointer class_data)
{
    //TRACE("%s called.", __func__)
}

static void gttp_idynlist_class_finalize(gpointer g_class, gpointer class_data)
{
    //TRACE("%s called.", __func__)
}

