#ifndef GTTMCOMMON_H_
#define GTTMCOMMON_H_

#include <glib.h>
#include <gmodule.h>
#include <glib-object.h>
#include <t2c.h>


//Required for TRACE macros
extern int bVerbose;
extern const char* test_name_;
extern const char* suite_subdir_;


typedef struct _GTTMModuleImpl_CT{
    gint load_module_cc;
    gint unload_module_cc;



    GTypeModule* load_pmodule;
    GTypeModule* unload_pmodule;

    gboolean module_allow_load;
    gboolean module_allow_open_module;
    gboolean module_allow_register_types;

    gboolean module_symbol_error;
    gboolean module_close_error;
    gboolean module_open_error;

    //g_type_module_register_type
    GType gtmrt_rgtype;

} GTTMModuleImpl_CT;

GTTMModuleImpl_CT gttmmodule_ct;

#endif /*GTTMCOMMON_H_*/
